/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (3.1.2).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package org.openapitools.v1_0.provenance;

import org.json.JSONException;
import org.openapitools.v1_0.model.Error;
import org.springframework.core.io.Resource;
import io.swagger.annotations.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Optional;
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2023-09-15T12:23:18.056Z[GMT]")

@Validated
@Api(value = "provenance", description = "the provenance API")
public interface ProvenanceApi {

    default Optional<NativeWebRequest> getRequest() {
        return Optional.empty();
    }

    @ApiOperation(value = "Saves provided provenance template expansion.", nickname = "createProvenance", notes = "Saves the expanded binding as a prov-n to the database.", tags={ "provenance", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success"),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/provenance",
        produces = { "application/json" }, 
        consumes = { "application/octet-stream" },
        method = RequestMethod.POST)
    default ResponseEntity<?> createProvenance(@ApiParam(value = ""  )  @Valid @RequestBody Resource body) throws IOException {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Returns the information about an activity based on the activityId", nickname = "getActivityById", notes = "Returns the information about an activity based on the activityId", response = String.class, tags={ "provenance", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Succes", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/provenance/activity/{activityId}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    default ResponseEntity<?> getActivityById(@ApiParam(value = "Id of an activity",required=true) @PathVariable("activityId") String activityId) throws JSONException{
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Returns the session and pool ids associated with this service id", nickname = "getServiceSessionIds", notes = "Returns the session and pool ids associated with this service id", response = String.class, tags={ "provenance", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Succes", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/provenance/service/{serviceId}/sessionIds",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    default ResponseEntity<?> getServiceSessionIds(@ApiParam(value = "Id of a service.",required=true) @PathVariable("serviceId") String serviceId) throws JSONException{
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Returns the list of activities that are related to the session with their id's properties", nickname = "getSessionActivity", notes = "Returns the list of activities that are related to the session with their id's properties", response = String.class, tags={ "provenance", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success", response = String.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/provenance/session/{sessionId}/activities",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    default ResponseEntity<?> getSessionActivity(@ApiParam(value = "Id of a session.",required=true) @PathVariable("sessionId") String sessionId,@ApiParam(value = "Option for username") @Valid @RequestParam(value = "person", required = false) String person,@ApiParam(value = "Show only activities associated with given pool id.") @Valid @RequestParam(value = "poolId", required = false) String poolId,@ApiParam(value = "Show only activities associated with given service id.") @Valid @RequestParam(value = "serviceId", required = false) String serviceId,@ApiParam(value = "Show only activities of the given type.") @Valid @RequestParam(value = "type", required = false) String type,@ApiParam(value = "Include workflow runs belonging to the session.") @Valid @RequestParam(value = "includeRuns", required = false) Boolean includeRuns,@ApiParam(value = "Include some additional fields in the response to make it easier to create an overview.") @Valid @RequestParam(value = "includeAdditionalInfo", required = false) Boolean includeAdditionalInfo) throws JSONException {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }

}
